﻿Imports System.Drawing.Imaging

Public Class Brush3 : Inherits Brush
    Private _l As Layer

    Public Overrides ReadOnly Property i() As Image
        Get
            Dim value As Image
            If w > 0 And _pt <> Point.Empty Then
                value = New Bitmap(w, w)
                Dim g = Graphics.FromImage(value)
                Dim c As PointF = New PointF(value.Size.Width / 2, value.Size.Height / 2)
                With Me
                    Dim cm = New ColorMatrix()
                    cm.Matrix00 = 1.25F
                    cm.Matrix11 = 1.0F
                    cm.Matrix22 = 1.0F
                    cm.Matrix33 = 0.5F
                    cm.Matrix44 = 1.0F
                    Dim ia = New ImageAttributes()
                    ia.SetColorMatrix(cm)
                    ' b2
                    g.DrawImage(_l.b2, New Rectangle(Point.Empty, value.Size), _pt.X, _pt.Y, w, w, GraphicsUnit.Pixel, ia)
                End With

                Dim mask = New Bitmap(value.Size.Width, value.Size.Height)
                Dim gmask = Graphics.FromImage(mask)
                gmask.CompositingMode = Drawing2D.CompositingMode.SourceCopy
                gmask.Clear(Color.FromArgb(255, 255, 255, 255))
                gmask.FillPie(New SolidBrush(Color.FromArgb(0, 0, 0, 0)), 0, 0, mask.Width, mask.Height, 0, 360)

                value = m(CType(value, Bitmap), mask)
            Else
                value = New Bitmap(1, 1)
            End If
            Return value
        End Get
    End Property

    Public WriteOnly Property l() As Layer
        Set(ByVal value As Layer)
            _l = value
        End Set
    End Property

    Private Function m(ByVal src As Bitmap, ByVal mask As Bitmap) As Bitmap
        Dim r = New Bitmap(src.Size.Width, src.Size.Height)
        For x = 0 To r.Size.Width - 1
            For y = 0 To r.Size.Height - 1
                Dim c = mask.GetPixel(x, y)
                If c.A = 0 Then
                    r.SetPixel(x, y, src.GetPixel(x, y))
                Else
                    r.SetPixel(x, y, Color.Transparent)
                End If
            Next
        Next
        m = r
    End Function

    Sub New()
        _separation = 0.25
    End Sub
End Class
