﻿Public Class Canvas
    Private _l As Layer

    Public ReadOnly Property activel() As Layer
        Get
            Return _l.activeLayer
        End Get
    End Property

    Public ReadOnly Property l() As Layer
        Get
            Return _l
        End Get
    End Property

    Public Property b() As Bitmap
        Get
            Return _l.b
        End Get
        Set(ByVal value As Bitmap)
            _l.b = value
        End Set
    End Property

    Public Property g() As Graphics
        Get
            Return _l.g()
        End Get
        Set(ByVal value As Graphics)
            _l.g = value
        End Set
    End Property

    Function Save() As String
        Dim p As Imaging.EncoderParameters
        p = New Imaging.EncoderParameters(2)
        p.Param(0) = New Imaging.EncoderParameter(Imaging.Encoder.ColorDepth, CType(24L, Int32))
        p.Param(1) = New Imaging.EncoderParameter(Imaging.Encoder.Quality, CType(50L, Int32))
        Dim enc As Imaging.ImageCodecInfo
        enc = Nothing
        With Me
            Dim enclist As Imaging.ImageCodecInfo()
            enclist = Imaging.ImageCodecInfo.GetImageEncoders()
            For Each enc In enclist
                If enc.FormatID = Imaging.ImageFormat.Jpeg.Guid Then
                    Exit For
                End If
            Next
        End With
        Dim d As String
        Try
            d = My.Computer.FileSystem.SpecialDirectories.Desktop
        Catch e As IO.DirectoryNotFoundException
            d = My.Computer.FileSystem.SpecialDirectories.Temp
        Catch e As Exception
            d = String.Empty
        End Try
        If Not String.IsNullOrEmpty(d) And enc IsNot Nothing Then
            _l.b.Save(System.IO.Path.Combine(d, My.Application.Info.ProductName & ".jpg"), enc, p)
        End If
        Return System.IO.Path.Combine(d, My.Application.Info.ProductName & ".jpg")
    End Function

    Sub ClearLayer()
        _l.Clear()
    End Sub

    Sub CreateLayer()
        _l.CreateLayer()
    End Sub

    Sub Draw(ByVal b As ClassLibrary2.IBrush, ByVal ps As Point, ByVal pe As Point)
        _l.Draw(b, ps, pe)
    End Sub

    Public Sub New(ByVal width As Integer, ByVal height As Integer)
        _l = New Layer(width, height, Color.White)
    End Sub
End Class
