﻿Public Class Form1
    Private _p As Paint
    Private _pf As Boolean
    Private _pt As Point
    Private _pr As Integer

    Dim WithEvents Tablet As VBTablet.Tablet

    Private Sub PacketArrival(ByRef ContextHandle As System.IntPtr, ByRef Cursor As Integer, ByRef X As Integer, ByRef Y As Integer, ByRef Z As Integer, ByRef Buttons As Integer, ByRef NormalPressure As Integer, ByRef TangentPressure As Integer, ByRef Azimuth As Integer, ByRef Altitude As Integer, ByRef Twist As Integer, ByRef Pitch As Integer, ByRef Roll As Integer, ByRef Yaw As Integer, ByRef PacketSerial As Integer, ByRef PacketTime As Integer) Handles Tablet.PacketArrival
        _pt = Me.PointToClient(New Point(X, Screen.PrimaryScreen.Bounds.Height - Y))
        _pr = NormalPressure
        _pf = NormalPressure > 0
    End Sub

    Public Sub RefreshImage()
        PictureBox1.CreateGraphics().DrawImage(_p.b, 0, 0)
    End Sub

    Private Sub Form1_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        Tablet.Connected = False
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        PictureBox1.Image = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        _p = New Paint(PictureBox1.Width, PictureBox1.Height)

        Tablet = New VBTablet.Tablet()
        Tablet.hWnd = Me.Handle.ToInt32()
        Tablet.Connected = True
        Tablet.Context.Enabled = True
        Tablet.Context.Update()
        Tablet.Context.QueueSize = 4

        _pf = False
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        If _pf Then
            _p.Down(_pt)
        Else
            _p.Down(New Point(e.X, e.Y))
            _pr = 1024 / 4
        End If
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        If _pf Then
            _p.Move(_pt, _pr)
        Else
            _p.Move(New Point(e.X, e.Y), _pr)
        End If
        RefreshImage()
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
        If _pf Then
            _p.Up(_pt)
        Else
            _p.Up(New Point(e.X, e.Y))
        End If
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        RefreshImage()
    End Sub

    Private Sub Form1_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If PictureBox1.Image IsNot Nothing AndAlso PictureBox1.Height > 0 Then
            Dim i As Image
            Dim ig As Graphics

            i = _p.b
            ig = _p.g

            ig.DrawImage(PictureBox1.Image, 0, 0)

            PictureBox1.Image = i
            _p.CreateImage(PictureBox1.Width, PictureBox1.Height)
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Static Dim c As Integer
        Select Case c
            Case 0
                _p.CreateLayer()
                Button1.Text = "Clear Layer"
            Case Else
                _p.ClearLayer()
                PictureBox1.Invalidate()
        End Select
        c = Math.Min(c + 1, 1)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        _p.SaveCanvas()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        _p.ClearLayer()
        PictureBox1.Invalidate()
        _p.Play()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        _p.SetBrush(CheckBox1.Checked)
    End Sub
End Class
