﻿Public Class Layer
    Private _s As Size
    Private _g As Graphics
    Private _b As Bitmap
    Private _l() As Layer
    Private _activeLayer As Layer
    Private _bg As Color

    Private ReadOnly Property _targetLayer() As Layer
        Get
            Dim l As Layer
            l = IIf(_activeLayer Is Nothing, Me, _activeLayer)
            Debug.Assert(l IsNot Nothing)
            Return l
        End Get
    End Property

    Public Property activeLayer() As Layer
        Get
            Return _activeLayer
        End Get
        Set(ByVal value As Layer)
            _activeLayer = value
        End Set
    End Property

    Public Property b2() As Bitmap
        Get
            Return _b
        End Get
        Set(ByVal value As Bitmap)
            _targetLayer._b = value
        End Set
    End Property

    Public Property b() As Bitmap
        Get
            If _targetLayer Is Me Then
                Return _targetLayer._b
            Else
                Dim b_ As Bitmap
                Dim g_ As Graphics
                b_ = New Bitmap(_s.Width, _s.Height)
                g_ = Graphics.FromImage(b_)
                g_.DrawImage(_b, 0, 0)
                g_.DrawImage(_targetLayer._b, 0, 0)
                Return b_
            End If
        End Get
        Set(ByVal value As Bitmap)
            _targetLayer._b = value
        End Set
    End Property

    Public Property g() As Graphics
        Get
            If _targetLayer Is Me Then
                Return _targetLayer._g
            Else
                Dim g_ As Graphics
                g_ = Graphics.FromImage(_b)
                g_.DrawImage(_targetLayer._b, 0, 0)
                Return g_
            End If
        End Get
        Set(ByVal value As Graphics)
            _targetLayer._g = value
        End Set
    End Property

    Sub Clear()
        If _targetLayer Is Me Then
            _g.Clear(_bg)
        Else
            _targetLayer.Clear()
        End If
    End Sub

    Sub CreateLayer()
        If _targetLayer Is Me Then
            Dim l As Layer
            ReDim Preserve _l(_l.Length - 1 + 1)
            l = New Layer(_s.Width, _s.Height, Color.Transparent)
            _l(_l.Length - 1) = l
            _activeLayer = l
        Else
            _targetLayer.CreateLayer()
        End If
    End Sub

    Sub Draw(ByVal b As ClassLibrary2.IBrush, ByVal ps As Point, ByVal pe As Point)
        Static _x, _y
        Dim a, k
        a = IIf((pe.X - ps.X) <> 0, (pe.Y - ps.Y) / (pe.X - ps.X), 1)
        k = ps.Y - a * ps.X
        If Math.Abs(pe.X - ps.X) >= Math.Abs(pe.Y - ps.Y) Then
            For x = ps.X To pe.X Step Math.Max(b.w * b.separation, 1) * IIf(ps.X <= pe.X, 1, -1)
                Dim y = a * x + k
                Dim r = IIf((y - _y) <> 0, Math.Atan(-(x - _x) / (y - _y)), 0)
                b.r = r
                b.pt = New Point(x, y)
                Dim i As Image = b.i()
                Dim w = i.Size.Width
                Dim h = i.Size.Height
                Dim q = New PointF(w / 2, h / 2)
                Dim org = New PointF(x - q.X, y - q.Y)
                _targetLayer._g.ResetTransform()
                _targetLayer._g.TranslateTransform(org.X, org.Y)
                _targetLayer._g.DrawImage(i, New RectangleF(0, 0, w, h), i.GetBounds(GraphicsUnit.Pixel), GraphicsUnit.Pixel)
                _x = x : _y = y
            Next
        Else
            For y = ps.Y To pe.Y Step Math.Max(b.w * b.separation, 1) * IIf(ps.Y <= pe.Y, 1, -1)
                Dim x = (y - k) / a
                Dim r = IIf((y - _y) <> 0, Math.Atan(-(x - _x) / (y - _y)), 0)
                b.r = r
                b.pt = New Point(x, y)
                Dim i As Image = b.i()
                Dim w = i.Size.Width
                Dim h = i.Size.Height
                Dim q = New PointF(w / 2, h / 2)
                Dim org = New PointF(x - q.X, y - q.Y)
                _targetLayer._g.ResetTransform()
                _targetLayer._g.TranslateTransform(org.X, org.Y)
                _targetLayer._g.DrawImage(i, New RectangleF(0, 0, w, h), i.GetBounds(GraphicsUnit.Pixel), GraphicsUnit.Pixel)
                _x = x : _y = y
            Next
        End If
    End Sub

    Protected Overrides Sub Finalize()
        _g.Dispose()
        MyBase.Finalize()
    End Sub

    Public Sub New(ByVal width As Integer, ByVal height As Integer, ByVal c As Color)
        ReDim _l(0)
        _s = New Size(width, height)
        _b = New Bitmap(_s.Width, _s.Height)
        _g = Graphics.FromImage(_b)
        '_g.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBicubic
        _bg = c
        _g.Clear(_bg)
        _activeLayer = Nothing
    End Sub
End Class
